%define tarball xf86-video-mga
%define moduledir %(pkg-config xorg-server --variable=moduledir )
%define driverdir	%{moduledir}/drivers
%define _default_patch_fuzz 2

%ifarch %{ix86} x86_64 ia64 ppc alpha sparc sparc64
%define with_dri        1
%else
%define with_dri        0
%endif

Summary:   Xorg X11 mga video driver
Name:      xorg-x11-drv-mga
Version:   1.4.13
Release:   2%{?dist}
URL:       http://www.x.org
License:   MIT/X11
Group:     User Interface/X Hardware Support
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Source0:   ftp://ftp.x.org/pub/individual/driver/%{tarball}-%{version}.tar.bz2
Source1:   mga.xinf

Patch0: blank-on-init.patch
Patch1: mga-1.4.10-shadowfb.patch
Patch3: mga-1.4.10-g200se-24-not-32.patch
Patch6: mga-1.4.13-revision-reg.patch
Patch7: mga-1.4.13-g200er.patch

ExclusiveArch: %{ix86} x86_64 ia64 alpha sparc sparc64

BuildRequires: pkgconfig
BuildRequires: xorg-x11-server-sdk >= 1.1.1-48.64.el5
%if %{with_dri}
BuildRequires: mesa-libGL-devel >= 6.4-4
BuildRequires: libdrm-devel >= 2.0-1
%endif

Requires:  xorg-x11-server-Xorg >= 1.1.1-48.64.el5

%description 
X.Org X11 mga video driver.

%prep
%setup -q -n %{tarball}-%{version}

%patch0 -p1 -b .blank-on-init
%patch1 -p1 -b .shadowfb
%patch3 -p1 -b .24
%patch6 -p1 -b .rev
%patch7 -p1 -b .g200er

%build
%configure --disable-static --disable-exa
make

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_datadir}/hwdata/videoaliases
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/hwdata/videoaliases/

# FIXME: Remove all libtool archives (*.la) from modules directory.  This
# should be fixed in upstream Makefile.am or whatever.
find $RPM_BUILD_ROOT -regex ".*\.la$" | xargs rm -f --

# NOTE: Intentionally remove hardware specific utilities, we generally do not
# supply these in the core OS.
#rm $RPM_BUILD_ROOT%{_bindir}/stormdwg

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{moduledir}
%dir %{driverdir}
%{driverdir}/mga_drv.so
%{_datadir}/hwdata/videoaliases/mga.xinf
#%dir %{_mandir}/man4x
%{_mandir}/man4/mga.4*

%changelog
* Mon Feb 14 2011 Adam Jackson <ajax@redhat.com> 1.4.13-2
- mga-1.4.13-g200er.patch: Update for G200ER. (#661286, #656962, #651468)

* Fri Sep 10 2010 Adam Jackson <ajax@redhat.com> 1.4.13-1
- Update to 1.4.13+git for G200EH. (#569554)

* Tue Feb 23 2010 Adam Jackson <ajax@redhat.com> 1.4.10-7
- mga-1.4.10-g200wb-no-ddc1.patch: Don't try DDC1 on G200WB (#563196)

* Thu Feb 11 2010 Adam Jackson <ajax@redhat.com> 1.4.10-6
- what-the-revert-meant-to-do.patch: Only do that for memory-constrained
  cards. (#518997)

* Tue Aug 04 2009 Adam Jackson <ajax@redhat.com> 1.4.10-5
- what-the-revert-meant-to-do.patch: Fix up pitch misestimation when better
  modes are filtered away due to hardware limitations. (#508039)

* Tue Jul 28 2009 Adam Jackson <ajax@redhat.com> 1.4.10-4
- mga-1.4.10-g200se-24-not-32.patch: Prefer 24bpp on G200SE-A due to
  scarce memory bandwidth. (#508039)

* Mon Jul 20 2009 Adam Jackson <ajax@redhat.com> 1.4.10-3
- mga-1.4.10-revert.patch: Unbreak 800x600 on lowmem cards. (#509914)

* Mon Jun 15 2009 Adam Jackson <ajax@redhat.com> 1.4.10-2
- Bump Requires: and BuildRequires: to avoid version skew bugs.

* Wed May 27 2009 Adam Jackson <ajax@redhat.com> 1.4.10-1
- Update to 1.4.10 (#479919)
- mga-1.4.10-shadowfb.patch: Force shadowfb on lowmem G200SE to avoid
  XAA offscreen memory accounting bugs. (#479919)

* Wed Apr 22 2009 Adam Jackson <ajax@redhat.com> 1.4.2-11
- mga-1.4.2-version.patch: Fix version reported in X log. (#474209)

* Mon Dec 22 2008 Adam Jackson <ajax@redhat.com> 1.4.2-10
- mga-1.4.2-g200-ev-wb.patch: Even more PLL tweaking for G200SE, only seems to
  be stable when P is a power of two. (#474168)

* Mon Dec 08 2008 Adam Jackson <ajax@redhat.com> 1.4.2-9
- mga-1.4.2-g200-ev-wb.patch: Restore PLL search behaviour for G200SE
  parts. (#474168)

* Mon Sep 01 2008 Adam Jackson <ajax@redhat.com> 1.4.2-8
- mga-1.4.2-g200-ev-wb.patch: Add support for G200EV and G200WB, and fix
  DDC on all G200[A-Z][A-Z] parts. (#445497)

* Sat Jan 19 2008 Adam Jackson <ajax@redhat.com> 1.4.2-7
- mga-1.4.2-g200se-a-updates.patch: Update for G200SE-A. (#251139)

* Tue Aug 07 2007 Adam Jackson <ajax@redhat.com> 1.4.2-6
- mga-1.4.2-g200se-default-mode.patch: Tweak for G200SE to use the settings
  from the default Display subsection in xorg.conf, so that changes from
  s-c-d will make their way into the driver. (#228705)

* Tue Dec 12 2006 Adam Jackson <ajax@redhat.com> 1.4.2-5.el5
- mga-1.4.2-unbreak-dri.patch: Fix a boolean logic error from the G200SE
  merge that broke DRI on, well, everything else. (#217579)

* Wed Dec 6 2006 Adam Jackson <ajax@redhat.com> 1.4.2-4.el5
- mga-1.4.2-g200se-default-mode.patch: Fix defaults for G200SE to fit
  1024x768x16 @ 60Hz. (#215949)

* Wed Dec 6 2006 Adam Jackson <ajax@redhat.com> 1.4.2-3.el5
- mga-1.4.2-g200se-crash.patch: Fix hangs when saving and restoring video.
- mga-1.4.2-g200se-disable-mtrr.patch: Disable MTRR for PCIE G200SEs.

* Wed Nov 08 2006 Soren Sandmann <sandmann@redhat.com> 1.4.2-2.el5
- Add .blank-on-init, which clears the framebuffer before setting the
  initial mode. (#210297).

* Mon Nov 6 2006 Adam Jackson <ajackson@redhat.com> 1.4.2-1.el5
- Update to 1.4.2.  (#213053)

* Thu Oct 12 2006 Adam Jackson <ajackson@redhat.com> 1.4.1-5.1.el5
- Remove from ppc builds.  (#204393)

* Fri Aug 18 2006 Kristian Høgsberg <krh@redhat.com> 1.4.1-5.fc6
- Add Tilman Sauerbecks patch to fix DRI locking.

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> 1.4.1-4.1
- rebuild

* Thu Jul  6 2006 Adam Jackson <ajackson@redhat.com> 1.4.1-4
- mga.xinf updates.  Add G200SE cards, remove Impression and Mistral IDs
  (since they do not and never have worked), and comment each line with
  the appropriate card name.

* Fri May 26 2006 Mike A. Harris <mharris@redhat.com> 1.4.1-3
- Added with_dri conditionalization (not yet working for non-dri case).
- Added "BuildRequires: libdrm-devel >= 2.0-1" for (#192358).
- Added "BuildRequires: mesa-libGL-devel >= 6.4-4".
- Bumped sdk dep to pick up proto-devel indirectly.

* Sun Apr  9 2006 Adam Jackson <ajackson@redhat.com> 1.4.1-2
- Update to 1.4.1 from 7.1RC1.

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> 1.2.1.3-1.2
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> 1.2.1.3-1.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Wed Jan 18 2006 Mike A. Harris <mharris@redhat.com> 1.2.1.3-1
- Updated xorg-x11-drv-mga to version 1.2.1.3 from X11R7.0

* Tue Dec 20 2005 Mike A. Harris <mharris@redhat.com> 1.2.1.2-1
- Updated xorg-x11-drv-mga to version 1.2.1.2 from X11R7 RC4
- Removed 'x' suffix from manpage dirs to match RC4 upstream.

* Wed Nov 16 2005 Mike A. Harris <mharris@redhat.com> 1.2.1-1
- Updated xorg-x11-drv-mga to version 1.2.1 from X11R7 RC2

* Fri Nov 4 2005 Mike A. Harris <mharris@redhat.com> 1.2.0.1-1
- Updated xorg-x11-drv-mga to version 1.2.0.1 from X11R7 RC1
- Fix *.la file removal.
- Remove hardware specific {_bindir}/stormdwg utility.

* Mon Oct 3 2005 Mike A. Harris <mharris@redhat.com> 1.1.2-1
- Update BuildRoot to use Fedora Packaging Guidelines.
- Deglob file manifest.
- Limit "ExclusiveArch" to x86, x86_64, ia64, ppc

* Fri Sep 2 2005 Mike A. Harris <mharris@redhat.com> 1.1.2-0
- Initial spec file for mga video driver generated automatically
  by my xorg-driverspecgen script.
